import {NgModule} from '@angular/core';
import {CommonModule} from '@angular/common';
import {PreviousRouteRecorder} from '../openaireLibrary/utils/piwik/previousRouteRecorder.guard';

import {PiwikService} from '../openaireLibrary/utils/piwik/piwik.service';
import {RouterModule} from "@angular/router";
import {FormsModule, ReactiveFormsModule} from "@angular/forms";
import {AlertModalModule} from "../openaireLibrary/utils/modal/alertModal.module";
import {StakeholderComponent} from "./stakeholder.component";
import {StakeholderRoutingModule} from "./stakeholder-routing.module";
import {InputModule} from "../openaireLibrary/dashboard/sharedComponents/input/input.module";
import {ClickModule} from "../openaireLibrary/utils/click/click.module";
import {AdminDashboardGuard} from "../utils/adminDashboard.guard";

@NgModule({
  imports: [
    CommonModule, StakeholderRoutingModule, ClickModule, RouterModule, FormsModule, AlertModalModule, ReactiveFormsModule, InputModule
  ],
  declarations: [
    StakeholderComponent
  ],
  providers: [
    AdminDashboardGuard, PreviousRouteRecorder,
    PiwikService
  ],
  exports: [
    StakeholderComponent
  ]
})
export class StakeholderModule {
}
